<?php
/**
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 */
class PhpMessageSource extends CPhpMessageSource
{
    /**
     * @var bool Flag. If true try to use dictionary files from custom section
     */
    public $customI18n;

    /**
     * Determines the message file name based on the given category and language.
     * If the category name contains a dot, it will be split into the module class name and the category name.
     * In this case, the message file will be assumed to be located within the 'messages' subdirectory of
     * the directory containing the module class file.
     * Otherwise, the message file is assumed to be under the {@link basePath}.
     *
     * @param string $category category name
     * @param string $language language ID
     *
     * @return string the message file path
     */
    protected function getMessageFile($category, $language)
    {
        $file = realpath(parent::getMessageFile($category, $language));
        if ($this->customI18n) {
            $customSection = realpath(Yii::getPathOfAlias('site.custom'));
            $commonSection = realpath(Yii::getPathOfAlias('site.common'));
            $frontendSection = realpath(Yii::getPathOfAlias('site.frontend'));
            $customFile = str_replace(array($commonSection, $frontendSection), $customSection, $file);
            if (file_exists($customFile)) {
                return $customFile;
            }
        }

        return $file;
    }

}
