(function($) {
	
	/**
	 * FormGenerator namespace
	 * @namespace $.fg
	 */
	$.fg = {};
	
	/**
	 * @class Config
	 */
	$.fg.Config = {
		
		/**
		 * Base path of application
		 * @type {string}
		 */
		basePath: '/formgenerator',
		
		/**
		 * Url of server side script that will be handle editor client ajax requests
		 * {action} will be replaced with requesting action name
		 * @type {string}
		 */
		serverEditorActionsUrl: '/fg/editor/{action}',
		

		/**
		 * Url of server side script that will be handle form ajax requests
		 * {action} will be replaced with requesting action name
		 * @type {string}
		 */
		serverFormActionsUrl: '/fg/form/{action}',
		
		/**
		 * Default editor language
		 * @type {string}
		 */
		defaultLanguage: 'en',
		
		/**
		 * List of available languages
		 * @type {object}
		 */
		languages: {
			'en': 'English',
			'ru': 'Русский'
		}
		
	};
	
})(jQuery);
