<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */

$request = Yii::app()->request;
?>
<div class="like-widget" id="like_widget_<?php echo $model->content_id;?>">
    <a name="lw<?php echo $model->content_id;?>"></a>
    <?php
    if (Yii::app()->user->isGuest) {
        if (!$this->isPreview) {
            echo CHtml::link('<span>' . LikeModule::t('Log in to Like') . '</span>', Yii::app()->createUrl('/like/like/login', array('return_url' => Yii::app()->request->getRequestUri() . '#lw' . $model->content_id)), array('class' => 'likebutton'));
        } else {
            echo CHtml::link('<span>' . LikeModule::t('Log in to Like') . '</span>', Yii::app()->createUrl(''), array('class' => 'likebutton'));
        }
    } else {
        ?>
        <?php if ($hasLiked) { ?>
            <a href="javascript:;" class="likebutton like_href"
               id="like_href_<?php echo $model->content_id;?>"><span><?php echo LikeModule::t('Unlike'); ?></span></a>
            <?php } else { ?>
            <a href="javascript:;" class="likebutton like_href"
               id="like_href_<?php echo $model->content_id;?>"><span><?php echo LikeModule::t('Like'); ?></span></a>
            <?php } ?>
        <?php } ?>

    <span class="top_likes_container" id="top_likes_container_<?php echo $model->content_id;?>">
        <?php
        if ($model->topLikesQty > 0 && count($model->likes) > 0) {
            $topLikes = array();
            for ($i = 0; $i < $model->topLikesQty && $i < count($model->likes); $i++) {
                if (isset($model->likes[$i]->profile)
                    && $model->likes[$i]->profile->user_id == Yii::app()->user->id) {
                    $topLikes[] = LikeModule::t('You');
                } elseif (isset($model->likes[$i]->profile)
                    && ($name = trim($model->likes[$i]->profile->firstname.' '.$model->likes[$i]->profile->lastname))) {
                    $topLikes[] = $name;
                } else {
                    $topLikes[] = LikeModule::t('Noname');
                }
            }
            echo implode(', ', $topLikes);
        }
        ?>
    </span>

    <a href="javascript:;" class="and_others_container" id="and_others_container_<?php echo $model->content_id;?>"
       style="display:<?php echo (count($model->likes) > $model->topLikesQty) ? '' : 'none'?>;">
        <?php
        if (count($model->likes) > $model->topLikesQty) {
            echo LikeModule::t('and') . ' ' . ($model->likesQty - $model->topLikesQty) . ' ' . LikeModule::t('others like this');
        }
        ?>
    </a>

    <div class="last_likes_overlay" id="last_likes_overlay_<?php echo $model->content_id;?>">
        <?php if ($model->lastLikesQty > 0 && (count($model->likes) - $model->topLikesQty) > 0) { ?>
        <?php
        $lastLikes = array();
        for ($i = $model->topLikesQty; $i < ($model->topLikesQty + $model->lastLikesQty) && $i < count($model->likes); $i++) {
            if (isset($model->likes[$i]->profile) && is_object($model->likes[$i]->profile) && is_object($model->likes[$i]->profile->firstname) && is_object($model->likes[$i]->profile->lastname) 
			    && (trim($model->likes[$i]->profile->firstname) != '' && trim($model->likes[$i]->profile->lastname) != '')) {
                $lastLikes[] = $model->likes[$i]->profile->firstname . ' ' . $model->likes[$i]->profile->lastname;
            } else {
                $lastLikes[] = LikeModule::t('Noname');
            }
        }

        if (count($model->likes) > ($model->topLikesQty + $model->lastLikesQty)) {
            $lastLikes[] = LikeModule::t('And others...');
        }

        echo implode('<br/>', $lastLikes);
    }
        ?>
    </div>
</div>
<?php
if (!$this->isPreview) {
    ?>
<script type="text/javascript">
    $(document).ready(function () {
        likeButton({
            url:"<?php echo Yii::app()->createUrl('/like/like'); ?>",
            contentId:"<?php echo $model->content_id;?>",
            el:$('#like_href_<?php echo $model->content_id;?>'),
            topLikesContainer:$('#top_likes_container_<?php echo $model->content_id;?>'),
            andOthersContainer:$('#and_others_container_<?php echo $model->content_id;?>'),
            lastLikesContainer:$('#last_likes_overlay_<?php echo $model->content_id;?>'),
            hiddenFields: <?php echo CJSON::encode($request->enableCsrfValidation ? array($request->csrfTokenName => $request->getCsrfToken()) : array())?>
        });

        toggleButton({
            el:$('#and_others_container_<?php echo $model->content_id;?>'),
            overlay:$('#last_likes_overlay_<?php echo $model->content_id;?>')
        });
    });
</script>
<?php
}
?>