<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */

//  cacheId includes current widget settings, updatetimestamp for given content and current user personalisation settings
$cacheId = $this->createCacheKey();

if ($this->beginCache($cacheId, array('duration' => Yii::app()->getModule('navigation')->cacheTime))) {

    $data = $tree->cleanUp(Yii::app()->user->id, $this->usePersonalisation);

    /*  if $this->hideFirstLevel is true then we should show children of current node's children */
    if ($this->hideFirstLevel && !empty($data['children'])) {
        $fakeChildren = array();
        foreach ($data['children'] as &$node) {
            if (!empty($node['children']) && in_array($node['contentid'], $this->activePath)) {
                $fakeChildren = array_merge($fakeChildren, $node['children']);
                break;
            }
        }

        if (!empty($fakeChildren)) {
            $this->render('_branch', array('branch' => $fakeChildren, 'lvl' => 1));
        }

    } else if (!empty($data['children'])) {
        $this->render('_branch', array('branch' => $data['children'], 'lvl' => 1));
    }

    $this->endCache();
}
?>