<?php
/**
 *
 */
class GenController extends CController
{

    public function actionIndex($url, $key)
    {
        if ($this->module->encrypt($url) !== $key) {
            throw new CHttpException(400, 'Wrong key!');
        }

        if (!file_exists($this->pdfFileLocation($url))) {
            if (!$this->module->allowExternalLinks) {
                $finalUrl = Yii::app()->createAbsoluteUrl($url);
            } else {
                $finalUrl = $url;
            }
            $html = file_get_contents($finalUrl);
            $pdfRenderer = new WkHtmlToPdf(array('bin' => $this->module->wkhtmltopdfBin));
            $cssFile = PdfHelper::grabCssToSingleFile($html, Yii::getPathOfAlias($this->module->assetsFolder), $this->module->cssExpirationTime);
            if ($cssFile) {
                $pdfRenderer->setOptions(array('user-style-sheet' => $cssFile));
            }
            $pdfRenderer->addPage($finalUrl);
            if (!$pdfRenderer->saveAs($this->pdfFileLocation($url))) {
                throw new Exception($pdfRenderer->getError());
            }
        }
        $this->outputToBrowser($this->pdfFileLocation($url));
    }

    private function outputToBrowser($file)
    {
        Yii::app()->request->sendFile(basename($file), file_get_contents($file));

        //one way
//        $this->redirect($this->module->pdfWebPath . '/' . $this->urlToFileName($url));

        //other way
//        $pdf = file_get_contents($file);
//
//        header('Content-Type: application/pdf');
//        header('Cache-Control: public, must-revalidate, max-age=0'); // HTTP/1.1
//        header('Pragma: public');
//        header('Expires: Sat, 26 Jul 1997 05:00:00 GMT'); // Date in the past
//        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
//        header('Content-Length: ' . strlen($pdf));
//        header('Content-Disposition: inline; filename="' . basename($file) . '";');
//        ob_clean();
//        flush();
//        echo $pdf;
//        die;
    }

    private function pdfFileLocation($url)
    {
        return Yii::getPathOfAlias($this->module->pdfFolder) . '/' . $this->urlToFileName($url);
    }

    private function urlToFileName($url)
    {
        return str_replace(array('/', ':'), '_', $url) . '.pdf';
    }

}
