<?php
$request = Yii::app()->request;
?>
<div class="success-message" style="display:none; background-color:green;">
    <?php echo RememberModule::t('Successfull done!') ?>
</div>
<div class="mail-form">
    <?php $form = $this->beginWidget('CActiveForm', array(
                'id' => 'share-by-mail-form',
                'action' => Yii::app()->createUrl('/remember/manage/shareByMail'),
                'enableAjaxValidation' => true,
                'htmlOptions' => array(
                    'style' => 'display:none'    
                ),
                'clientOptions' => array(
                    'validateOnSubmit' => true,
                    'validateOnChange' => false,
                    'afterValidate' => 'js:
                        function (form, data, hasError){
                            console.log(form, data, hasError);
                            if(!hasError){
                                $(form).find("input[type=text], textarea").each(function(i, input){$(input).val("");}); 
                                successMessage();
                            }
                            return false;
                        } 
                    '
                    ),
                )) ?>
    <?php echo $form->errorSummary($mailForm) ?>
    
    <div class="row">
        <?php echo $form->labelEx($mailForm, 'name'); ?>
        <?php echo $form->textField($mailForm, 'name') ?>
        <?php echo $form->error($mailForm, 'name'); ?>
    </div>
    <div class="row">
        <?php echo $form->labelEx($mailForm, 'email'); ?>
        <?php echo $form->textField($mailForm, 'email') ?>
        <?php echo $form->error($mailForm, 'email'); ?>
    </div>
    <div class="row">
        <?php echo $form->labelEx($mailForm, 'description'); ?>
        <?php echo $form->textArea($mailForm, 'description') ?>
        <?php echo $form->error($mailForm, 'description'); ?>
    </div>
    <?php echo $form->hiddenField($mailForm, 'links') ?>
    <div class="row">
        <?php echo CHtml::submitButton(RememberModule::t("Submit")); ?>
    </div>
    <?php $this->endWidget() ?>
</div>
<?php
    $buttonsTemplate = '';
    if (Yii::app()->getModule('remember')->shareByMailEnabled) {
        $buttonsTemplate = '{share_facebook}<br/>{share_mail}<br/>{remove}';
    } else {
        $buttonsTemplate = '{share_facebook}<br/>{remove}';
    }

    $this->widget('zii.widgets.grid.CGridView', array(
    'id' => 'share-remembered-pages',
    'dataProvider' => $model->search($this->pageSize,$this->collection_id),
    'filter' => $model,
    'rowCssClassExpression' => '"page_$data->id"',
    'columns' => array(
        /*
        array(
            'header' => RememberModule::t('Select'),
            'type' => 'raw',
            'value' => 'CHtml::checkBox(get_class($data)."_selected_".$data->id, false, array("class" => "action-checkbox", "value" => $data->id))',
            // Check box select/deselect all
            'footer' => '<input type="checkbox" class="select-all">'
        ),
        **/
        'id',
        array(
            'name' => 'title',
            'htmlOptions' => array(
                'class' => 'remember-page-title',
            ),
            // Dropdown global action
            //'footer' => CHtml::dropDownList('action','',array('mail_share' => RememberModule::t('Share mail'), 'print' => RememberModule::t('Print'), 'delete' => RememberModule::t('Delete')), array('class' => 'action')) . CHtml::button(RememberModule::t('Ok'), array('name' => 'ok_button')),
        ),
        array(
            'name' => 'url',
            'htmlOptions' => array('class' => 'remember-page-url')
        ),
        'page_id',
        array(
            'header' => RememberModule::t('created'),
            'name' => 'created',
            'sortable' => false,
            'value' => 'Yii::app()->dateFormatter->formatDateTime($data->created)'
        ),
        // start additional fields
        // they displaying in this way @$data->additional['key']
        array(
            'header' => RememberModule::t('Category'),
            'sortable' => false,
            'value' => '@$data->additional[0]'
        ),
        array(
            'header' => RememberModule::t('Level'),
            'sortable' => false,
            'value' => '@$data->additional[1]'
        ),
        //end additional fields
        array(
            'class' => 'CButtonColumn',
            'header' => RememberModule::t('Actions'),
            'template' => $buttonsTemplate,
            'buttons' => array(
                'share_facebook' => array(
                    'label' => RememberModule::t('Share facebook'),
                    'url' => '$data->fbSharerUrl',
                    'options' => array('class' => 'share-fb-link')
                    //'imageUrl' => $this->module->getAssetsUrl() . '/user-rights.gif',
                ),
                'share_mail' => array(
                    'label' => RememberModule::t('Share mail'),
                    'url' => '"javascript:void(0)"',
                    //'imageUrl' => $this->module->getAssetsUrl() . '/user-rights.gif',
                    'options' => array('class' => 'share-mail-link')
                ),
                /*
                'print' => array(
                    'label' => RememberModule::t('Print'),
                    'url' => '"javascript:void(0)"',
                    //'imageUrl' => $this->module->getAssetsUrl() . '/user-rights.gif',
                    'options' => array('class' => 'print-link')
                ),
                */
                'remove' => array(
                    'label' => RememberModule::t('Delete'),
                    'url' => 'Yii::app()->createUrl("/remember/manage/deletePage",
                                                    array(
                                                        "id"=>$data->id,
                                                        "collection_id" => EncryptHelper::encrypt($data->collection_id)
                                                    )
                                                )',
                    //'imageUrl' => $this->module->getAssetsUrl() . '/user-rights.gif',
                ),
            ),
            //'htmlOptions' => array('style' => 'width:64px')
        ),

))); ?>
<script>
    $(function(){

        //attach handlers
        $(document).on('click', '#share-remembered-pages .select-all', function(){
            if($(this).attr('checked')){
                $('.action-checkbox').attr('checked', true);
            }else{
                $('.action-checkbox').removeAttr('checked');
            }
        });
        $(document).on('click','#share-remembered-pages .share-fb-link', function(){
            var message = makeMessage($(this).closest('tr'));
            shareFb(message);
        });
        $(document).on('click','#share-remembered-pages .share-mail-link', function(){
            var message = makeMessage($(this).closest('tr'));
            shareEmail(message);
        });
        $(document).on('click','#share-remembered-pages .print-link', function(){
            var $message = $(this).closest('tr');
            printLinks(makeMessage($message));
        });
        $(document).on('click','#share-remembered-pages [name="ok_button"]', function(){
            var $checkboxes = $('.action-checkbox:checked');
            if($checkboxes.length === 0){
                return;
            }
            var action = $('#share-remembered-pages .action option:selected').val();
            console.log(action);
            if(action === 'fb_share'){
                shareFb(makeMessageForChecked());
            }else if(action === 'mail_share'){
                shareEmail(makeMessageForChecked());
            }else if(action === 'delete') {
                deleteAll();
            }else if(action === 'print') {
                printLinks(makeMessageForChecked());
            }
        });
        //helper fuctions
        function makeMessage(el){
            return $(el).find('.remember-page-url').text();
        }
        function makeMessageForChecked(){
            var $checkboxes = $('.action-checkbox:checked');
            var message = '';
            $checkboxes.each(function(i, el){
               message += makeMessage($(el).closest('tr'));
            });
            return message;
        }
        //sharing functions
        function shareFb(message){
            var obj = {
                message: message,
            };
            console.log(obj);
            var postFbMessage = function(){
                FB.api('/me/feed','post',obj, function(response){
                    console.log(response);
                    successMessage();
                });
            }
            FB.getLoginStatus(function(response) {
                console.log(response);
                if (response.status === 'connected') {
                    // connected
                    postFbMessage();
                } else if (response.status === 'not_authorized') {
                    // not_authorized
                    fbLogin(postFbMessage);
                } else {
                    // not_logged_in
                    fbLogin(postFbMessage);
                }
            });
        }
        function shareEmail(message){
            var $form = $('#share-by-mail-form');
            $form.show();
            $form.find('[name="ShareMailForm[links]"]').val(message);
        }
        function deleteAll(){
            if(!confirm('Are you sure you want to delete this items?')) return false;
            var th=this;
            var checkboxes = $('#share-remembered-pages .action-checkbox:checked');
            var pageIds = [];
            checkboxes.each(function(i, el){
                pageIds.push($(el).val());
            });
            console.log(pageIds);
            var csrf = <?php echo CJSON::encode($request->enableCsrfValidation ? array($request->csrfTokenName => $request->getCsrfToken()) : array())?>;

            $.get('<?php echo Yii::app()->createUrl('/remember/manage/deletePage')?>',
                     $.extend({}, {id : pageIds.join(',')}, csrf),
                    function(data){
                        data = jQuery.parseJSON(data);
                        if(data.status != undefined && data.status == 'success'){
                            pageIds.forEach(function(element, index, array){
                               $('.page_'+element).remove();
                            });
                        }
                    }
                );
            return false;
        }

        function printLinks(links)
        {
            var disp_setting="toolbar=yes,location=no,directories=yes,menubar=yes,";
            disp_setting+="scrollbars=yes,width=650, height=600, left=100, top=25";
            var content_vlue = links;

            var docprint=window.open("","",disp_setting);
            //docprint.document.open();
            $(docprint.document.body).append(links);
            $(docprint.document.body).append($('<input>').attr({'type':'button', 'value': 'Print', 'onclick': 'window.print()'}));
            //docprint.document.write(content_vlue);
            //docprint.document.write($('<input>').attr({'type':'button'}).html());
            //docprint.document.close();
            docprint.focus();
        }
    });
    function successMessage(){
        $('#share-by-mail-form').hide();
        var $success = $('.success-message');
        $success.show();
        setTimeout(function (){$success.hide()}, 3000);
    }
</script>
<script>
    //facebook initialisation
    /*
    window.fbAsyncInit = function() {
        FB.init({
            appId      : '<?php echo Yii::app()->getModule('remember')->facebookApplicationId ?>', // App ID
            status     : true, // check login status
            cookie     : true, // enable cookies to allow the server to access the session
            xfbml      : true  // parse XFBML
        });
    };

    // Load the SDK Asynchronously
    (function(d){
        var js, id = 'facebook-jssdk', ref = d.getElementsByTagName('script')[0];
        if (d.getElementById(id)) {return;}
        js = d.createElement('script'); js.id = id; js.async = true;
        js.src = "//connect.facebook.net/en_US/all.js";
        ref.parentNode.insertBefore(js, ref);
    }(document));
    */

    function fbLogin(callback) {
        FB.login(function(response) {
            console.log('login', response);
            if (response.authResponse) {
                // connected
                callback();
            } else {
                // cancelled
            }
        },{scope: 'publish_stream'});
    }
</script>

