<?php
/**
 *
 */
?>
<div class="user-login-widget">
    <?php if ($message = Yii::app()->user->getFlash(Yii::app()->getModule('user')->userLoginWidgetFlashError)) { ?>
    <div class="error">
        <?php echo $message?>
    </div>
    <?php } ?>

    <?php if ($message = Yii::app()->user->getFlash(Yii::app()->getModule('user')->userLoginWidgetFlashSuccess)) { ?>
    <div class="success">
        <?php echo $message?>
    </div>
    <?php }?>

    <div class="user-login-widget-form">
        <a name="UserLoginWidget"></a>
        <?php $form = $this->beginWidget('CActiveForm', array(
            'id' => 'login-form',
            'method' => 'post',
            //'action' => Yii::app()->createUrl('/user/login/standard', array('return_url' => Yii::app()->request->getParam('return_url', Yii::app()->request->getRequestUri() . '#UserLoginWidget'))),
            'enableAjaxValidation' => true,
            'clientOptions' => array(
                'validateOnSubmit' => Yii::app()->getModule('user')->loginAjax,
            ),
        )
    );?>
        <?php echo $form->errorSummary($model); ?>

        <div class="row">
            <?php echo $form->labelEx($model, 'service'); ?>
            <?php
            echo $form->dropDownList($model, 'service', $this->services, array('id' => 'service'));
            //echo $form->textField($model, 'service', array('id' => 'service'));
            ?>
            <?php echo $form->error($model, 'service'); ?>
        </div>

        <div class="row email-service">
            <?php echo $form->labelEx($model, 'authField'); ?>
            <?php echo $form->textField($model, 'authField', array('class' => 'non-oauth-input')) ?>
            <?php echo $form->error($model, 'authField'); ?>
        </div>
        <div class="nofloat"></div>

        <div class="row email-service <?php echo $model->hasErrors('password') ? 'error' : ''?>">
            <?php echo $form->labelEx($model, 'password'); ?>
            <?php echo $form->passwordField($model, 'password', array('class' => 'non-oauth-input')) ?>
            <?php echo $form->error($model, 'password', array(), false, false); ?>
        </div>
        <div class="nofloat"></div>

        <div class="row email-service">
            <?php echo $form->labelEx($model, 'rememberMe'); ?>
            <?php echo $form->checkBox($model, 'rememberMe') ?>
            <?php echo $form->error($model, 'rememberMe'); ?>
        </div>
        <div class="nofloat"></div>

        <?php if ($this->isUseStandard()): ?>
        <div class="row email-service">
            <?php echo CHtml::link(UserModule::t('Forgot your password?'), Yii::app()->createUrl($this->recoveryUrl)) ?>
        </div>
        <div class="nofloat"></div>
        <?php endif?>
        <div class="row">&nbsp;</div>
        
        <?php echo CHtml::hiddenField('return_url', Yii::app()->request->getParam('return_url', Yii::app()->request->getRequestUri() . '#UserLoginWidget')); ?>
        <div class="row submit">
            <?php echo CHtml::submitButton(UserModule::t("Login")); ?>
        </div>

        <?php $this->endWidget() ?>
    </div>

    <script type="text/javascript">
        $(function(){
            $('#service').change(function () {
                var serviceTypes = <?php echo CJSON::encode($this->serviceTypes)?>;
                var standardLoginUrl = '<?php echo Yii::app()->createUrl('/user/login/standard')?>';
                var tpaLoginUrl = '<?php echo Yii::app()->createUrl('/user/login/tpa')?>';
                if (serviceTypes[$(this).val()] != 'standard') {
                    $('.email-service').hide();
                    $('.non-oauth-input').attr('disabled', 'disabled');
                    $('#login-form').attr('action', tpaLoginUrl);
                    $('#login-form').attr('method', 'get');
                    $.fn.yiiactiveform.getSettings($('#login-form')).validationUrl = tpaLoginUrl;
                } else {
                    $('.email-service').show();
                    $('.non-oauth-input').removeAttr('disabled');
                    $('#login-form').attr('action', standardLoginUrl);
                    $('#login-form').data('settings').validationUrl = standardLoginUrl;
                    $('#login-form').attr('method', 'post');
                }
            });
            setTimeout(function(){$('#service').change()}, 500);
        });
    </script>
</div>
