<div class="user-registration-widget">
    <a name="UserRegistrationWidget"></a>

    <h2><?php echo UserModule::t("Registration"); ?></h2>

    <?php if (Yii::app()->user->hasFlash('registration')): ?>
    <div class="success">
        <?php echo Yii::app()->user->getFlash('registration'); ?>
    </div>
    <?php else: ?>

    <div class="form">
        <?php
        $form = $this->beginWidget('CActiveForm', array(
            'id' => 'registration-form',
            'action' => Yii::app()->createUrl('/user/registration', array('return_url' => Yii::app()->request->getRequestUri() . '#UserRegistrationWidget')),
            'enableAjaxValidation' => true,
//    'clientValidation' => true,
//    'disableAjaxValidationAttributes' => array('RegistrationForm_verifyCode'),
            'htmlOptions' => array('enctype' => 'multipart/form-data'),
            'clientOptions' => array(
                'validateOnSubmit' => true,
                'afterValidate' => 'js:jumpToTop'
            )
        )); ?>
        <script type="text/javascript">
            function jumpToTop(form, data, hasError) {
                $('body').scrollTop($('#registration-form').offset().top);
                return !hasError;
            }
        </script>

        <p class="note"><?php echo UserModule::t('Fields with <span class="required">*</span> are required.'); ?></p>

        <?php echo $form->errorSummary(array($model, $profile)); ?>

        <?php if (Yii::app()->getModule('user')->usernameRequired): ?>
        <div class="row">
            <?php echo $form->labelEx($model, 'username'); ?>
            <?php echo $form->textField($model, 'username'); ?>
            <?php echo $form->error($model, 'username'); ?>
        </div>
        <div class="nofloat"></div>
        <?php endif;?>

        <div class="row">
            <?php echo $form->labelEx($model, 'email'); ?>
            <?php echo $form->textField($model, 'email'); ?>
            <?php echo $form->error($model, 'email'); ?>
        </div>
        <div class="nofloat"></div>

        <div class="row">
            <?php echo $form->labelEx($model, 'password'); ?>
            <?php echo $form->passwordField($model, 'password'); ?>
            <?php echo $form->error($model, 'password'); ?>
            <p class="hint">
                <?php echo UserModule::t("Minimal password length 4 symbols."); ?>
            </p>
        </div>
        <div class="nofloat"></div>

        <div class="row">
            <?php echo $form->labelEx($model, 'verifyPassword'); ?>
            <?php echo $form->passwordField($model, 'verifyPassword'); ?>
            <?php echo $form->error($model, 'verifyPassword'); ?>
        </div>
        <div class="nofloat"></div>

        <?php
        $profileFields = $profile->getFields();
        if ($profileFields) {
            foreach ($profileFields as $field) {
                ?>
                <div class="row">
                    <?php echo $form->labelEx($profile, $field->varname); ?>
                    <?php
                    if ($widget = $field->widgetEdit($profile)) {
                        echo $widget;
                    } elseif ($field->range) {
                        $pos = strpos($field->range, '-');
                        if ($pos === false) {
                            /*  show as dropdown box */
                            echo $form->dropDownList($profile, $field->varname, Profile::range($field->range));
                        } else {
                            $tag = substr($field->range, 0, $pos);
                            switch ($tag) {
                                case 'checkbox':
                                    $field->range = substr($field->range, $pos + 1);
                                    /*  show as checkbox    */
                                    echo $form->checkBox($profile, $field->varname, Array('uncheckValue' => ""));
                                    break;
                                case 'radio':
                                    $field->range = substr($field->range, $pos + 1);
                                    echo $form->radioButtonList($profile, $field->varname, Profile::range($field->range), array('labelOptions' => Array('class' => 'inline_label')));
                                    break;
                                case 'select':
                                    $field->range = substr($field->range, $pos + 1);
                                    echo $form->dropDownList($profile, $field->varname, Profile::range($field->range));
                                    break;
                                default:
                                    echo $form->dropDownList($profile, $field->varname, Profile::range($field->range));
                            }
                        }
                    } elseif ($field->field_type == "TEXT") {
                        echo$form->textArea($profile, $field->varname, array('rows' => 6, 'cols' => 50));
                    } else {
                        echo $form->textField($profile, $field->varname, array('size' => 60, 'maxlength' => (($field->field_size) ? $field->field_size : 255)));
                    }
                    ?>
                    <?php echo $form->error($profile, $field->varname); ?>
                </div>
                <div class="nofloat"></div>
                <?php
            }
        }
        ?>
        <?php if (UserModule::doCaptcha('registration')): ?>
        <div class="row">
            <?php echo $form->labelEx($model, 'verifyCode'); ?>

            <?php $this->widget('CCaptcha', array('captchaAction' => '/user/registration/captcha')); ?>
            <?php echo $form->textField($model, 'verifyCode'); ?>

            <p class="hint"><?php echo UserModule::t("Please enter the letters as they are shown in the image above."); ?>
                <br/><?php echo UserModule::t("Letters are not case-sensitive."); ?></p>
        </div>
        <div class="nofloat"></div>
        <?php endif; ?>

        <div class="row submit">
            <?php echo CHtml::submitButton(UserModule::t("Register")); ?>
        </div>

        <?php $this->endWidget(); ?>
    </div><!-- form -->
    <?php endif; ?>
</div>