var gtx_feEditor = function () {
        // function for reading get parameters
        function getParam(variable) { //filter parameters from url
            var query = window.location.search.substring(1);
            var vars = query.split("&");
            for (var i = 0; i < vars.length; i++) {
                var pair = vars[i].split("=");
                if (pair[0] == variable) {
                    return pair[1];
                }
            }
            return (false);
        }
        return {
            id: null,
            language: 'de',
            i18n: null,

            init: function (data) {
                var that = this;
                //this.id = Aloha.settings.plugins.gcn.id; //set id to the current pageId
                if(data.language !== ''){
                  this.language = data.language;
                }
                this.id = data.id;
                this.i18n = new Object();
                this.i18n['en'] = new Object({ // english version of panel labels
                    newpage: "new",
                    edit: "edit",
                    save: "save only",
                    publish: "publish",
                    cancel: "cancel",
                    pageid: "PageID",
                    folderid: "Folder",
          locked: "the page is currently locked by an other user"
                });
                this.i18n['de'] = new Object({ // german version of panel labels
                    newpage: "neu",
                    edit: "bearbeiten",
                    save: "nur speichern",
                    publish: "ver&ouml;ffentlichen",
                    cancel: "abbrechen",
                    pageid: "SeitenID",
                    folderid: "Ordner",
          locked: "Die Seite ist von einem anderen Benutzer gesperrt, deshalb wurde sie im Lesemodus geöffnet."
                });

                if (getParam('edit') == 'true') {
                    GCN.page(this.id, function (page) {
                        that._createUserPanel(true);
                        that._renderTagsInEditMode(true, that);
                        that._setClickHandlers();
                    });
                } else if (getParam('new') == 'true') {
                    GCN.page(this.id, function (page) {
                        that._createUserPanel(true);
                        that._renderTagsInEditMode(true, that)
                        that._setClickHandlers();
                    });
                } else {
                    this._createUserPanel(false);
                }
            },
            save: function () {
                GCN.page(this.id).save(); //save page
            },
            publish: function () {
                var that = this;
        GCN.page(this.id).save(function(page){
                                        page.publish(function(){
                                             window.location = window.location.pathname;
                                        });
                                 });        
            },
            cancel: function () {
         var that = this;
         GCN.page(this.id).unlock(function(){
                                        window.location = window.location.pathname;
                                 });        
            },
            // create new UserPanel if it doesn't exist or update the existing one
            _createUserPanel: function (inEditmode) { //inEditmode is used to decide if panel should show edit/new or publish,save,cancel
                var that = this;
                var i18n = that.i18n[that.language];
                var html = '';
                if (inEditmode) {
                    var folder = GCN.page(this.id).prop('folder');
                    html += '<span class="frontendpanel"><span class="pageid">' + i18n.pageid + ': ' + this.id + ' </span> | ';
                    html += '<a class="metanavlink" data-action="publish" href="#">' + i18n.publish + '</a> | ';
                    html += '<a class="metanavlink" data-action="save" href="#">' + i18n.save + '</a> | ';
                    html += '<a class="metanavlink" data-action="cancel" href="#">' + i18n.cancel + '</a> | ';
                    html += '<span class="folderid" data-folderid="' + folder.id + '"> ' + i18n.folderid + ': ' + folder.name + '</span></span>';
                }

                if ($('div.metanav').length > 0) {
                    if ($('div.metanav span.frontendpanel').length > 0) {
                        $('div.metanav span.frontendpanel').remove();
                        $('div.metanav').prepend(html);
                    } else {
                        $('div.metanav').prepend(html);
                    }
                } else {
                    $('body').prepend('<div class="metanav">' + html + '</div><div class="space"></div>');
                }
            },
            _setClickHandlers: function () {
                var that = this;
                $('.frontendpanel a.metanavlink').click(function () {
                    switch ($(this).attr('data-action')) {
                    case 'publish':
                        that.publish();
                        break;
                    case 'save':
                        that.save();
                        break;
                    case 'cancel':
                        that.cancel();
                        break;
                    default:
                        break;
                    }
                });
            },
            createPage: function (data) { //creates a new page in the same directory and with the same template as the current page
                var that = this;
                GCN.page(data.id, function (page) {
                    var templateid = page.prop('templateId'); //get templateId
                    var folderid = page.prop('folderId'); //get folderId
                    GCN.folder(folderid).createPage(templateid, {
                        language: data.language
                    }, function (newpage) { //create new page in current folder with the current template
                         var url = window.location.href.substring(0, top.location.href.indexOf('?'));
                         url += '?edit=true&pageid='+newpage.id();
                        window.location= url;
                    });
                });
            },
            _renderTagsInEditMode: function (edit, that) { //renders all tags that are defined for frontendediting (wrapping div with data-edit=true and tagname in editmode
          GCN.page(this.id, function (page) {
          if(edit===true){
            if(page.prop('readOnly')===true){
              that._renderTagsInEditMode(false, that);
              that._createUserPanel(false);
            }
          }
                    $('span[data-edit=true]').each(function () { //get all spans that are supposed to be frontendeditable
                        var that = this; //set that to this, so it can be accessed in tag success function
                        page.tag($(that).attr('data-tagname'), function (tag) { //get tagname from data attribute 
                            if (edit == true)tag.edit($(that)); //render tag in editmode
                            else{
                tag.render($(that));
              }
                        });
                    });
          
          $('div[data-edit=true]').each(function () { //get all divs that are supposed to be frontendeditable
                        var that = this; //set that to this, so it can be accessed in tag success function
                        page.tag($(that).attr('data-tagname'), function (tag) { //get tagname from data attribute 
                            if (edit == true) tag.edit($(that)); //render tag in editmode
                            else{
                tag.render($(that));//render tag in previewmode
              }
                        });
                    });
          if(edit != true){
            for (var i = Aloha.editables.length-1; i>=0; i--)  Aloha.editables[i].destroy();
          }
                });
            }     
        };
    }();
